/*
	Copyright (C) 2009 Karl Zeilhofer

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include "QtTelnet/qttelnet.h"
//#include <QtTelnet>
#include <QtGui/QWidget>
#include <QFile>

#define DIR_FILE_NAME "recentdir.dat"

namespace Ui
{
    class MainWidget;
}

class MainWidget : public QWidget
{
    Q_OBJECT

public:
    MainWidget(QWidget *parent = 0);
    ~MainWidget();

private:
    QString stripCR(const QString &msg);
    void removeEmptyLines();


private slots:
// control buttons
    void connectToServer();
    void resetOocd();
    void telnetMessage(const QString &msg);
    void telnetData();
    void ramFileSelect();
    void ramLoad();
    void flashFileSelect();
    void flashLoad();
// command buttons:
    void softReset();
    void reset();
    void halt();
    void resume();
    void poll();
    void eraseFlash();
    void showMem();
    void remap();
    void periphReset();
    void cpuReset();

private:
    Ui::MainWidget *ui;
    QtTelnet *tn;
    QString recentDir;
};

#endif // MAINWIDGET_H
